> ## Documentation Index
> Fetch the complete documentation index at: https://docs.x.com/llms.txt
> Use this file to discover all available pages before exploring further.

# Blocks

> The Blocks endpoints let you retrieve the list of users blocked by the authenticated user, as well. Reference for the X API v2 standard tier covering blocks.

export const Button = ({href, children}) => {
  return <div className="not-prose group">
    <a href={href}>
      <button className="flex items-center space-x-2.5 py-1 px-4 bg-primary-dark dark:bg-white text-white dark:text-gray-950 rounded-full group-hover:opacity-[0.9] font-medium">
        <span>
          {children}
        </span>
        <svg width="3" height="24" viewBox="0 -9 3 24" class="h-6 rotate-0 overflow-visible"><path d="M0 0L3 3L0 6" fill="none" stroke="currentColor" stroke-width="1.5" stroke-linecap="round"></path></svg>
      </button>
    </a>
  </div>;
};

The Blocks endpoints let you retrieve the list of users blocked by the authenticated user, as well as block and unblock users.

<Callout icon="key" color="#22C55E" iconType="regular">
  The block and unblock users endpoints are only available under the Enterprise plan. You can fill out the Enterprise interest form [here](/forms/enterprise-api-interest).
</Callout>

## Overview

<CardGroup cols={2}>
  <Card title="Blocked users" icon="list">
    Get your blocked user list
  </Card>

  <Card title="Block" icon="ban">
    Block a user
  </Card>

  <Card title="Unblock" icon="circle-check">
    Unblock a user
  </Card>
</CardGroup>

***

## Endpoints

| Method | Endpoint                                             | Description       | Availability                                                                                                                                                                    |
| :----- | :--------------------------------------------------- | :---------------- | :------------------------------------------------------------------------------------------------------------------------------------------------------------------------------ |
| GET    | [`/2/users/:id/blocking`](/x-api/users/get-blocking) | Get blocked users | <div className="flex items-center gap-1 flex-nowrap whitespace-nowrap"><Badge color="blue" size="xs">Pay-per-use</Badge><Badge color="green" size="xs">Enterprise</Badge></div> |
| POST   | `/2/users/:id/blocking`                              | Block a user      | <Badge color="green" size="xs">Enterprise</Badge>                                                                                                                               |
| DELETE | `/2/users/:source_user_id/blocking/:target_user_id`  | Unblock a user    | <Badge color="green" size="xs">Enterprise</Badge>                                                                                                                               |

***

## Example: Get blocked users

```bash theme={null}
curl "https://api.x.com/2/users/123456789/blocking?\
user.fields=username,description" \
  -H "Authorization: Bearer $USER_ACCESS_TOKEN"
```

## Example: Block a user (Enterprise only)

```bash theme={null}
curl -X POST "https://api.x.com/2/users/123456789/blocking" \
  -H "Authorization: Bearer $USER_ACCESS_TOKEN" \
  -H "Content-Type: application/json" \
  -d '{"target_user_id": "9876543210"}'
```

***

## Getting started

<Note>
  **Prerequisites**

  * An approved [developer account](https://developer.x.com/en/portal/petition/essential/basic-info)
  * A [Project and App](/resources/fundamentals/developer-apps) in the Developer Console
  * User Access Tokens via [OAuth 2.0 PKCE](/resources/fundamentals/authentication#oauth-2-0-authorization-code-flow-with-pkce-2)
</Note>

<CardGroup cols={2}>
  <Card title="Quickstart" icon="rocket" href="/x-api/users/blocks/quickstart">
    Get started with blocks
  </Card>

  <Card title="Integration guide" icon="book" href="/x-api/users/blocks/integrate">
    Key concepts and best practices
  </Card>

  <Card title="API Reference" icon="code" href="/x-api/users/get-blocking">
    Full endpoint documentation
  </Card>
</CardGroup>
